#!/usr/bin/ruby
# -*- coding: UTF-8 -*-

module Lazop
    class LazopRequest
        # this hash will hold all api params
        @api_params = nil
        # this hash will hold http header params
        @header_params = nil
        # this hash will hold byte arrays params , such as file path
        @file_params = nil

        @api_name = nil
        @http_method = 'POST'
        @timestamp = nil

        def initialize(api_name = nil,http_method = 'POST')
            @api_name , @http_method = api_name,http_method
            @api_params = Hash.new
            @header_params = Hash.new
            @file_params = Hash.new
        end

        def add_api_parameter(key,value)
            if key.kind_of? String
                @api_params[key] = value
            else
                raise 'api param key is not String'  
            end
        end

        def add_http_parameter(key,value)
            if key.kind_of? String
                @header_params[key] = value
            else
                raise 'http param key is not String'  
            end
        end

        # file_path must be String
        def add_file_parameter(key,file_path)
            if (key.kind_of? String) && (file_path.kind_of? String)
                @file_params[key] = file_path
            else
                raise 'http param key is not String'  
            end
        end

        def timestamp
            @timestamp
        end

        def set_timestamp=(value)
            @timestamp = value
        end

        def api_params
            @api_params
        end

        def api_name
            @api_name
        end

        def http_method
            @http_method
        end

        def file_params
            @file_params
        end

        def header_params
            @header_params
        end
    end
end